#include "FileReader.hpp"

const char* pVertexShader = R""""(
struct vOut
{
	float4 pos : SV_Position;
	float4 color : COLOR0;
	float2 uv : TEXCOORD0;
};

struct vIn
{
    float3 pos : POSITION;
    float4 color : COLOR0;
	float2 uv : TEXCOORD0;
};


vOut vs_main( vIn input )
{
	vOut vso;
	vso.pos = float4(input.pos,1.0f);
	vso.color = input.color;
	vso.uv = input.uv;

	return vso;
}
)"""";

const char* pPixelShader = R""""(
struct pIn
{
    float4 pos : SV_POSITION;
    float4 col : COLOR0;
	float2 uv : TEXCOORD0;
};
SamplerState defaultSampler : register(s0);
Texture2D defaultTexture : register(t0);

float4 ps_main(pIn input) : SV_Target
{
    return defaultTexture.Sample(defaultSampler,input.uv);
	return float4(input.uv,0,1.0f);
}

)"""";

#define STRING(x) #x"/"
#define XSTRING(x) STRING(x)

std::string FileReader::GetShaderData(std::string dataName)
{
	if (dataName == "VertexShader")
		return pVertexShader;
	else
		return pPixelShader;
}
