#pragma once

#include <d3dcompiler.h>
#include <d3d11.h>
#include <wrl.h>
#include <DirectXMath.h>

using namespace DirectX;
using namespace Microsoft::WRL;

class GraphicsDevice;

enum class DeviceObjectType
{
    None,
    Swapchain,
    Shader,
    CommandList,
    Pipeline,
    Framebuffer,
    SamplerState,
    Buffer
};

class DeviceObject
{
public:
    DeviceObject();
    DeviceObject(const DeviceObject&) = delete;
    DeviceObject& operator=(const DeviceObject&) = delete;
    virtual ~DeviceObject() = 0;

    virtual DeviceObjectType GetDeviceObjectType()
    { return DeviceObjectType::None; }
protected:
    GraphicsDevice* GraphicsDevice_;
};
