#pragma once

enum class BlendType
{
    Zero = 1,
    One,
    SourceColor,
    InvertedSourceColor,
    SourceAlpha,
    InvertedSourceAlpha,
    DestinationAlpha,
    InvertedDestinationAlpha,
    DestinationColor,
    InvertedDestinationColor,
    SourceAlphaSaturated,
    BlendFactor = 14,
    InvertedBlendFactor,
    Source1Color,
    InvertedSource1Color,
    Source1Alpha,
    InvertedSource1Alpha
};

enum class BlendOperation
{
    Add = 1,
    Subtract,
    ReverseSubtract,
    Minimum,
    Maximum
};

enum class ColorWriteEnable
{
    Red = 1,
    Green = 2,
    Blue = 4,
    Alpha = 8,
    All = (((Red | Green) | Blue) | Alpha)
};

struct RenderTargetBlendDesc
{
    bool BlendEnable;
    BlendType SrcBlend;
    BlendType DestBlend;
    BlendOperation BlendOp;
    BlendType SrcBlendAlpha;
    BlendType DestBlendAlpha;
    BlendOperation BlendOpAlpha;
    ColorWriteEnable RenderTargetWriteMask;
};

struct BlendStateDesc
{
    bool AlphaToCoverageEnable;
    bool IndependentBlendEnable;
    RenderTargetBlendDesc RenderTargetDesc;
};
