#pragma once

#include <vector>

enum class InputLayoutSemanticName
{
    Position,
    Normal,
    Tangent,
    Binormal,
    TexCoord,
    Color,
    Count
};

enum class MeshTopology
{
    TriangleList,
    LineList,
    PointList,
    PatchList
};

enum class InputSlotClass
{
    PerVertexData = 0,
    PerInstanceData = 1,
    Count = 2
};

struct InputAssemblerDesc
{
    std::vector<InputLayoutSemanticName> SemanticName_;
    std::vector<uint32_t> SemanticIndex_;
    std::vector<uint32_t> InputSlot_;
    std::vector<uint32_t> AlignedByteOffset_;
    std::vector<InputSlotClass> InputSlotClass_;
    std::vector<uint32_t> InstanceDataStepRate_;
    MeshTopology MeshTopology_;
};
