#pragma once

#include <stdint.h>

enum class FillMode
{
    Wireframe = 2,
    Solid
};

enum class CullMode
{
    None = 1,
    Front,
    Back
};

enum class FrontFace
{
    Clockwise = 0,
    CounterClockwise = 1
};

struct RasterizerStateDesc
{
    FillMode FillMode_;
    CullMode CullMode_;
    FrontFace FrontFace_;
    int DepthBias_;
    float DepthBiasClamp_;
    float SlopeScaledDepthBias_;
    bool DepthClipEnable_;
    bool ScissorEnable_;
    bool MultisampleEnable_;
    bool AntialiasedLineEnable_;
};