#include "SamplerState.hpp"

#include "Graphics/GraphicsCommon.hpp"
#include "Graphics/Device/GraphicsDevice.hpp"

SamplerState::SamplerState(GraphicsDevice* graphicsDevice) // TODO: Add SamplerStateDesc
{
    GraphicsDevice_ = graphicsDevice;

    D3D11_SAMPLER_DESC samplerDesc = {};
    samplerDesc.Filter = D3D11_FILTER_MIN_MAG_MIP_LINEAR;
    samplerDesc.AddressU = D3D11_TEXTURE_ADDRESS_WRAP;
    samplerDesc.AddressV = D3D11_TEXTURE_ADDRESS_WRAP;
    samplerDesc.AddressW = D3D11_TEXTURE_ADDRESS_WRAP;
    samplerDesc.MipLODBias = 0;
    samplerDesc.MaxAnisotropy = 0;
    samplerDesc.ComparisonFunc = D3D11_COMPARISON_NEVER;

    for(auto& el: samplerDesc.BorderColor) {
        el = 0.0f;
    }

    samplerDesc.MinLOD = 0;
    samplerDesc.MaxLOD = 0;

#ifdef ENGINE_DEBUG
    DX_PRINT("Create SamplerState", GraphicsDevice_->GetDevice()->CreateSamplerState(&samplerDesc, SamplerState_.GetAddressOf()));
#else
    GraphicsDevice_->GetDevice()->CreateSamplerState(&samplerDesc, SamplerState_.GetAddressOf());
#endif
}
