#pragma once

#include <d3d11.h>
#include <dxgi1_3.h>
#include <wrl.h>

using namespace Microsoft::WRL;

#include "Graphics/Device/DeviceObject.hpp"
#include "SwapchainDesc.hpp"

class GraphicsDevice;

class Swapchain : public DeviceObject
{
public:
    Swapchain(GraphicsDevice* graphicsDevice,SwapchainDesc desc);
    Swapchain(const Swapchain&) = delete;
    Swapchain& operator=(const Swapchain&) = delete;
    ~Swapchain() override;

    void InitializeSwapchain();
    void Present() { Swapchain_->Present(TRUE, 0); }

    ComPtr<ID3D11Texture2D> GetBackBuffer();

    DeviceObjectType GetDeviceObjectType() override;
private:
    ComPtr<IDXGISwapChain> Swapchain_;

    ComPtr<IDXGIDevice> dxgiDevice;
    ComPtr<IDXGIAdapter> dxgiAdapter;
    ComPtr<IDXGIFactory> dxgiFactory;
private:
    SwapchainDesc Desc_;
};

