#pragma once
#include <Graphics/GraphicsCommon.hpp>
#include <Graphics/Device/DeviceObject.hpp>
#include <d3d11.h>
#include <dxgi1_3.h>
#include <wrl.h>

using namespace Microsoft::WRL;
class Texture : public DeviceObject
{
public:
	Texture(const std::string& path,GraphicsDevice* pDevice);
	~Texture();

	FORCEINLINE ID3D11Texture2D* GetTexture() const noexcept { return mTexture.Get(); }
	FORCEINLINE ID3D11ShaderResourceView* GetSrv() const noexcept { return mSrv.Get(); }
private:
	ComPtr<ID3D11Texture2D> mTexture;
	ComPtr<ID3D11ShaderResourceView> mSrv;
};