#pragma once

#include <Graphics/Device/DeviceObject.hpp>
#include <Resources/BufferObject/BufferObjectDesc.hpp>

class GraphicsDevice;

class BufferObject : public DeviceObject
{
public:
    BufferObject(GraphicsDevice* device, BufferObjectDesc& desc);
    BufferObject(const BufferObject&) = delete;
    BufferObject& operator=(const BufferObject&) = delete;
    ~BufferObject() override = default;

    DeviceObjectType GetDeviceObjectType() override
    { return DeviceObjectType::Buffer; }

    void CreateBuffer();

    ComPtr<ID3D11Buffer>& GetBuffer() { return Buffer_; }
    BufferObjectDesc& GetDesc() { return Desc_; }
private:
    ComPtr<ID3D11Buffer> Buffer_;
    BufferObjectDesc Desc_;
};
