#pragma once

#include <cstdint>

enum class BufferObjectUsage
{
    Default,
    Immutable,
    Dynamic,
    Staging
};

enum class BufferObjectCPUAccessFlags
{
    None = 0,
    Read,
    Write,
    ReadWrite,
    WriteDiscard,
    WriteNoOverwrite
};

enum class BufferObjectBindFlags
{
    None = 0,
    VertexBuffer,
    IndexBuffer,
    ConstantBuffer,
    StructuredBuffer,
    RawBuffer,
    IndirectArgsBuffer
};

enum class BufferObjectMiscFlags
{
    None = 0,
    BufferStructured,
    BufferRaw,
    BufferAppend,
    BufferCounter,
    BufferStructuredAppend,
    BufferUAV,
    BufferUAVTyped,
    BufferUAVRaw,
    BufferUAVStructured,
    BufferUAVStructuredWithCounter
};

struct BufferObjectDesc
{
    BufferObjectUsage Usage;
    BufferObjectCPUAccessFlags CPUAccessFlags;
    BufferObjectBindFlags BindFlags;
    BufferObjectMiscFlags MiscFlags;
    uint64_t ByteWidth;
    uint64_t StructureByteStride;

    void* CPUData;
};