#pragma once

template<typename T>
class Singleton
{
public:
    Singleton(const Singleton& instance) = delete;
    Singleton& operator=(const Singleton& instance) = delete;

    static T& GetInstance()
    {
        if(Instance_ == nullptr)
            Instance_ = new T();
        return *Instance_;
    }
    
protected:
    Singleton() = default;
    virtual ~Singleton() = default;

private:
    static T* Instance_;
};
