#include "Window.h"
#include <Definitions.h>

Window::Window(const std::string& windowName, XMINT2 windowSize) : WindowSize_(windowSize), WindowName_(windowName)
{

}

Window::~Window()
{
    if(WindowInstance_)
        glfwTerminate();
}

void Window::InitializeWindow(bool fullScreen)
{
    glfwInit();

    int monitorCount = 0;
    GLFWmonitor** ppMonitors = glfwGetMonitors(&monitorCount);
    GLFWmonitor* pMonitor = ppMonitors[Defs::MonitorIndex];

    const GLFWvidmode* pVideoMode = glfwGetVideoMode(ppMonitors[Defs::MonitorIndex]);
    //glfwWindowHint(GLFW_DECORATED, GLFW_FALSE);
    glfwWindowHint(GLFW_CLIENT_API, GLFW_NO_API);
    //glfwWindowHint(GLFW_RED_BITS, pVideoMode->redBits);
    //glfwWindowHint(GLFW_GREEN_BITS, pVideoMode->greenBits);
    //glfwWindowHint(GLFW_BLUE_BITS, pVideoMode->blueBits);
    //glfwWindowHint(GLFW_REFRESH_RATE, pVideoMode->refreshRate);


    WindowInstance_ = glfwCreateWindow(Defs::WindowSizeX, Defs::WindowSizeY, WindowName_.c_str(), nullptr, nullptr);

    //glfwSetInputMode(WindowInstance_, GLFW_CURSOR, GLFW_CURSOR_HIDDEN);
    
    if (Defs::bFullscreen)
    {
        glfwSetWindowMonitor(WindowInstance_, ppMonitors[Defs::MonitorIndex], 0, 0, Defs::WindowSizeX, Defs::WindowSizeY, GLFW_DONT_CARE);

        glfwGetWindowSize(WindowInstance_, &WindowSize_.x, &WindowSize_.y);
    }
}

void Window::ProcessMessage()
{
    glfwPollEvents();
}


